<!DOCTYPE html><html><head>
    <meta charset="utf-8"/>
    <meta name="author" content="Apple Inc."/>
    <meta name="viewport" content="width=device-width initial-scale=1"/>
    
    <a class="dashingAutolink" name="autolink-10"></a><a class="dashAnchor" name="//apple_ref/cpp/Guide/Access%20Control%20%E2%80%94%20The%20Swift%20Programming%20Language%20%28Swift%204.2%29"></a><title>Access Control &mdash; The Swift Programming Language (Swift 4.2)</title>
    
    <link rel="license" href="https://docs.swift.org/LICENSE.txt"/>
    <link rel="stylesheet" media="all" href="../_static/stylesheets/application.css"/>
    <link rel="stylesheet" media="all" href="../_static/stylesheets/tspl.css"/>
    <link rel="shortcut icon" sizes="16x16 24x24 32x32 48x48 64x64" type="image/vnd.microsoft.icon" href="../../favicon.ico"/>
    <link rel="apple-touch-icon" href="https://docs.swift.org/apple-touch-icon.png"/>
    <link rel="apple-touch-icon" sizes="57x57" href="https://docs.swift.org/apple-touch-icon-57x57.png"/>
    <link rel="apple-touch-icon" sizes="72x72" href="https://docs.swift.org/apple-touch-icon-72x72.png"/>
    <link rel="apple-touch-icon" sizes="76x76" href="https://docs.swift.org/apple-touch-icon-76x76.png"/>
    <link rel="apple-touch-icon" sizes="114x114" href="https://docs.swift.org/apple-touch-icon-114x114.png"/>
    <link rel="apple-touch-icon" sizes="120x120" href="https://docs.swift.org/apple-touch-icon-120x120.png"/>
    <link rel="apple-touch-icon" sizes="144x144" href="https://docs.swift.org/apple-touch-icon-144x144.png"/>
    <link rel="apple-touch-icon" sizes="152x152" href="https://docs.swift.org/apple-touch-icon-152x152.png"/>
    <link rel="apple-touch-icon" sizes="180x180" href="https://docs.swift.org/apple-touch-icon-180x180.png"/>
    <link rel="mask-icon" href="https://docs.swift.org/assets/images/icon-swift.svg" color="#F05339"/> 
  </head>
  <body>


<nav role="navigation">
    <header role="banner">
      <h1 id="logo">
        <a href="https://swift.org/" title="Swift.org" role="img" aria-label="Swift.org">
          Swift.org
        </a>
      </h1>
    </header>

    <div id="menu-toggle" class="menu-toggle open"></div>

    <h2>The Swift Programming Language<div>Swift 4.2</div></h2>

    <ul>
    <ul class="current">
<li class="toctree-l1"><a class="reference internal" href="../index.html">Welcome to Swift</a></li>
<li class="toctree-l1 current"><a class="reference internal" href="TheBasics.html">Language Guide</a><ul class="current">
<li class="toctree-l2"><a class="reference internal" href="TheBasics.html">The Basics</a></li>
<li class="toctree-l2"><a class="reference internal" href="BasicOperators.html">Basic Operators</a></li>
<li class="toctree-l2"><a class="reference internal" href="StringsAndCharacters.html">Strings and Characters</a></li>
<li class="toctree-l2"><a class="reference internal" href="CollectionTypes.html">Collection Types</a></li>
<li class="toctree-l2"><a class="reference internal" href="ControlFlow.html">Control Flow</a></li>
<li class="toctree-l2"><a class="reference internal" href="Functions.html">Functions</a></li>
<li class="toctree-l2"><a class="reference internal" href="Closures.html">Closures</a></li>
<li class="toctree-l2"><a class="reference internal" href="Enumerations.html">Enumerations</a></li>
<li class="toctree-l2"><a class="reference internal" href="ClassesAndStructures.html">Structures and Classes</a></li>
<li class="toctree-l2"><a class="reference internal" href="Properties.html">Properties</a></li>
<li class="toctree-l2"><a class="reference internal" href="Methods.html">Methods</a></li>
<li class="toctree-l2"><a class="reference internal" href="Subscripts.html">Subscripts</a></li>
<li class="toctree-l2"><a class="reference internal" href="Inheritance.html">Inheritance</a></li>
<li class="toctree-l2"><a class="reference internal" href="Initialization.html">Initialization</a></li>
<li class="toctree-l2"><a class="reference internal" href="Deinitialization.html">Deinitialization</a></li>
<li class="toctree-l2"><a class="reference internal" href="OptionalChaining.html">Optional Chaining</a></li>
<li class="toctree-l2"><a class="reference internal" href="ErrorHandling.html">Error Handling</a></li>
<li class="toctree-l2"><a class="reference internal" href="TypeCasting.html">Type Casting</a></li>
<li class="toctree-l2"><a class="reference internal" href="NestedTypes.html">Nested Types</a></li>
<li class="toctree-l2"><a class="reference internal" href="Extensions.html">Extensions</a></li>
<li class="toctree-l2"><a class="reference internal" href="Protocols.html">Protocols</a></li>
<li class="toctree-l2"><a class="reference internal" href="Generics.html">Generics</a></li>
<li class="toctree-l2"><a class="reference internal" href="AutomaticReferenceCounting.html">Automatic Reference Counting</a></li>
<li class="toctree-l2"><a class="reference internal" href="MemorySafety.html">Memory Safety</a></li>
<li class="toctree-l2 current"><a class="current reference internal" href="AccessControl.html#">Access Control</a></li>
<li class="toctree-l2"><a class="reference internal" href="AdvancedOperators.html">Advanced Operators</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../ReferenceManual/AboutTheLanguageReference.html">Language Reference</a></li>
<li class="toctree-l1"><a class="reference internal" href="../RevisionHistory/RevisionHistory.html">Revision History</a></li>
</ul>

    <li class="toctree-l1 return"><a class="reference internal" href="https://swift.org/">&larr; Return to Swift.org</a></li>
    </ul>
</nav>




<main role="main">
    <article class="page">
        <menu id="bashful" type="toolbar">
          <div class="inner">
            <menuitem id="jump_to" class="menu-bar-item closed">
            <span id="jump_to_toggle">On This Page</span>
            <div class="chevron">
                <div class="chevy chevron-left"></div>
                <div class="chevy chevron-right"></div>
            </div>
            <menu type="list" class="details">
                <ul>
<li><a class="reference internal" href="AccessControl.html#">Access Control</a><ul>
<li><a class="reference internal" href="AccessControl.html#ID4">Modules and Source Files</a></li>
<li><a class="reference internal" href="AccessControl.html#ID5">Access Levels</a><ul>
<li><a class="reference internal" href="AccessControl.html#ID6">Guiding Principle of Access Levels</a></li>
<li><a class="reference internal" href="AccessControl.html#ID7">Default Access Levels</a></li>
<li><a class="reference internal" href="AccessControl.html#ID8">Access Levels for Single-Target Apps</a></li>
<li><a class="reference internal" href="AccessControl.html#ID9">Access Levels for Frameworks</a></li>
<li><a class="reference internal" href="AccessControl.html#ID519">Access Levels for Unit Test Targets</a></li>
</ul>
</li>
<li><a class="reference internal" href="AccessControl.html#ID10">Access Control Syntax</a></li>
<li><a class="reference internal" href="AccessControl.html#ID11">Custom Types</a><ul>
<li><a class="reference internal" href="AccessControl.html#ID12">Tuple Types</a></li>
<li><a class="reference internal" href="AccessControl.html#ID13">Function Types</a></li>
<li><a class="reference internal" href="AccessControl.html#ID14">Enumeration Types</a><ul>
<li><a class="reference internal" href="AccessControl.html#ID468">Raw Values and Associated Values</a></li>
</ul>
</li>
<li><a class="reference internal" href="AccessControl.html#ID15">Nested Types</a></li>
</ul>
</li>
<li><a class="reference internal" href="AccessControl.html#ID16">Subclassing</a></li>
<li><a class="reference internal" href="AccessControl.html#ID17">Constants, Variables, Properties, and Subscripts</a><ul>
<li><a class="reference internal" href="AccessControl.html#ID18">Getters and Setters</a></li>
</ul>
</li>
<li><a class="reference internal" href="AccessControl.html#ID19">Initializers</a><ul>
<li><a class="reference internal" href="AccessControl.html#ID20">Default Initializers</a></li>
<li><a class="reference internal" href="AccessControl.html#ID21">Default Memberwise Initializers for Structure Types</a></li>
</ul>
</li>
<li><a class="reference internal" href="AccessControl.html#ID22">Protocols</a><ul>
<li><a class="reference internal" href="AccessControl.html#ID23">Protocol Inheritance</a></li>
<li><a class="reference internal" href="AccessControl.html#ID24">Protocol Conformance</a></li>
</ul>
</li>
<li><a class="reference internal" href="AccessControl.html#ID25">Extensions</a><ul>
<li><a class="reference internal" href="AccessControl.html#ID559">Private Members in Extensions</a></li>
</ul>
</li>
<li><a class="reference internal" href="AccessControl.html#ID26">Generics</a></li>
<li><a class="reference internal" href="AccessControl.html#ID27">Type Aliases</a></li>
</ul>
</li>
</ul>

            </menu>
            </menuitem>
          </div>
        </menu>

        
  <div class="section" id="access-control">
<h1>Access Control<a class="headerlink" href="AccessControl.html#access-control" title="Permalink to this headline"></a></h1>
<p><em>Access control</em> restricts access to parts of your code from code in other source files and modules. This feature enables you to hide the implementation details of your code, and to specify a preferred interface through which that code can be accessed and used.</p>
<p>You can assign specific access levels to individual types (classes, structures, and enumerations), as well as to properties, methods, initializers, and subscripts belonging to those types. Protocols can be restricted to a certain context, as can global constants, variables, and functions.</p>
<p>In addition to offering various levels of access control, Swift reduces the need to specify explicit access control levels by providing default access levels for typical scenarios. Indeed, if you are writing a single-target app, you may not need to specify explicit access control levels at all.</p>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p class="last">The various aspects of your code that can have access control applied to them (properties, types, functions, and so on) are referred to as &ldquo;entities&rdquo; in the sections below, for brevity.</p>
</div>
<div class="section" id="ID4">
<a class="dashingAutolink" name="autolink-11"></a><a class="dashAnchor" name="//apple_ref/cpp/Section/Modules%20and%20Source%20Files"></a><h2>Modules and Source Files<a class="headerlink" href="AccessControl.html#ID4" title="Permalink to this headline"></a></h2>
<p>Swift&rsquo;s access control model is based on the concept of modules and source files.</p>
<p>A <em>module</em> is a single unit of code distribution&mdash;a framework or application that is built and shipped as a single unit and that can be imported by another module with Swift&rsquo;s <code class="docutils literal"><span class="pre">import</span></code> keyword.</p>
<p>Each build target (such as an app bundle or framework) in Xcode is treated as a separate module in Swift. If you group together aspects of your app&rsquo;s code as a stand-alone framework&mdash;perhaps to encapsulate and reuse that code across multiple applications&mdash;then everything you define within that framework will be part of a separate module when it&rsquo;s imported and used within an app, or when it&rsquo;s used within another framework.</p>
<p>A <em>source file</em> is a single Swift source code file within a module (in effect, a single file within an app or framework). Although it&rsquo;s common to define individual types in separate source files, a single source file can contain definitions for multiple types, functions, and so on.</p>
</div>
<div class="section" id="ID5">
<a class="dashingAutolink" name="autolink-12"></a><a class="dashAnchor" name="//apple_ref/cpp/Section/Access%20Levels"></a><h2>Access Levels<a class="headerlink" href="AccessControl.html#ID5" title="Permalink to this headline"></a></h2>
<p>Swift provides five different <em>access levels</em> for entities within your code. These access levels are relative to the source file in which an entity is defined, and also relative to the module that source file belongs to.</p>
<ul class="simple">
<li><em>Open access</em> and <em>public access</em> enable entities to be used within any source file from their defining module, and also in a source file from another module that imports the defining module. You typically use open or public access when specifying the public interface to a framework. The difference between open and public access is described below.</li>
<li><em>Internal access</em> enables entities to be used within any source file from their defining module, but not in any source file outside of that module. You typically use internal access when defining an app&rsquo;s or a framework&rsquo;s internal structure.</li>
<li><em>File-private access</em> restricts the use of an entity to its own defining source file. Use file-private access to hide the implementation details of a specific piece of functionality when those details are used within an entire file.</li>
<li><em>Private access</em> restricts the use of an entity to the enclosing declaration, and to extensions of that declaration that are in the same file. Use private access to hide the implementation details of a specific piece of functionality when those details are used only within a single declaration.</li>
</ul>
<p>Open access is the highest (least restrictive) access level and private access is the lowest (most restrictive) access level.</p>
<p>Open access applies only to classes and class members, and it differs from public access as follows:</p>
<ul class="simple">
<li>Classes with public access, or any more restrictive access level, can be subclassed only within the module where they&rsquo;re defined.</li>
<li>Class members with public access, or any more restrictive access level, can be overridden by subclasses only within the module where they&rsquo;re defined.</li>
<li>Open classes can be subclassed within the module where they&rsquo;re defined, and within any module that imports the module where they&rsquo;re defined.</li>
<li>Open class members can be overridden by subclasses within the module where they&rsquo;re defined, and within any module that imports the module where they&rsquo;re defined.</li>
</ul>
<p>Marking a class as open explicitly indicates that you&rsquo;ve considered the impact of code from other modules using that class as a superclass, and that you&rsquo;ve designed your class&rsquo;s code accordingly.</p>
<div class="section" id="ID6">
<h3>Guiding Principle of Access Levels<a class="headerlink" href="AccessControl.html#ID6" title="Permalink to this headline"></a></h3>
<p>Access levels in Swift follow an overall guiding principle: <em>No entity can be defined in terms of another entity that has a lower (more restrictive) access level.</em></p>
<p>For example:</p>
<ul class="simple">
<li>A public variable can&rsquo;t be defined as having an internal, file-private, or private type, because the type might not be available everywhere that the public variable is used.</li>
<li>A function can&rsquo;t have a higher access level than its parameter types and return type, because the function could be used in situations where its constituent types are unavailable to the surrounding code.</li>
</ul>
<p>The specific implications of this guiding principle for different aspects of the language are covered in detail below.</p>
</div>
<div class="section" id="ID7">
<h3>Default Access Levels<a class="headerlink" href="AccessControl.html#ID7" title="Permalink to this headline"></a></h3>
<p>All entities in your code (with a few specific exceptions, as described later in this chapter) have a default access level of internal if you don&rsquo;t specify an explicit access level yourself. As a result, in many cases you don&rsquo;t need to specify an explicit access level in your code.</p>
</div>
<div class="section" id="ID8">
<h3>Access Levels for Single-Target Apps<a class="headerlink" href="AccessControl.html#ID8" title="Permalink to this headline"></a></h3>
<p>When you write a simple single-target app, the code in your app is typically self-contained within the app and doesn&rsquo;t need to be made available outside of the app&rsquo;s module. The default access level of internal already matches this requirement. Therefore, you don&rsquo;t need to specify a custom access level. You may, however, want to mark some parts of your code as file private or private in order to hide their implementation details from other code within the app&rsquo;s module.</p>
</div>
<div class="section" id="ID9">
<h3>Access Levels for Frameworks<a class="headerlink" href="AccessControl.html#ID9" title="Permalink to this headline"></a></h3>
<p>When you develop a framework, mark the public-facing interface to that framework as open or public so that it can be viewed and accessed by other modules, such as an app that imports the framework. This public-facing interface is the application programming interface (or API) for the framework.</p>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p class="last">Any internal implementation details of your framework can still use the default access level of internal, or can be marked as private or file private if you want to hide them from other parts of the framework&rsquo;s internal code. You need to mark an entity as open or public only if you want it to become part of your framework&rsquo;s API.</p>
</div>
</div>
<div class="section" id="ID519">
<h3>Access Levels for Unit Test Targets<a class="headerlink" href="AccessControl.html#ID519" title="Permalink to this headline"></a></h3>
<p>When you write an app with a unit test target, the code in your app needs to be made available to that module in order to be tested. By default, only entities marked as open or public are accessible to other modules. However, a unit test target can access any internal entity, if you mark the import declaration for a product module with the <code class="docutils literal"><span class="pre">@testable</span></code> attribute and compile that product module with testing enabled.</p>
</div>
</div>
<div class="section" id="ID10">
<a class="dashingAutolink" name="autolink-13"></a><a class="dashAnchor" name="//apple_ref/cpp/Section/Access%20Control%20Syntax"></a><h2>Access Control Syntax<a class="headerlink" href="AccessControl.html#ID10" title="Permalink to this headline"></a></h2>
<p>Define the access level for an entity by placing one of the <code class="docutils literal"><span class="pre">open</span></code>, <code class="docutils literal"><span class="pre">public</span></code>, <code class="docutils literal"><span class="pre">internal</span></code>, <code class="docutils literal"><span class="pre">fileprivate</span></code>, or <code class="docutils literal"><span class="pre">private</span></code> modifiers before the entity&rsquo;s introducer:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">public</span> <span class="k">class</span> <span class="nv">SomePublicClass</span> {}
</li><li><span class="k">internal</span> <span class="k">class</span> <span class="nv">SomeInternalClass</span> {}
</li><li><span class="k">fileprivate</span> <span class="k">class</span> <span class="nv">SomeFilePrivateClass</span> {}
</li><li><span class="k">private</span> <span class="k">class</span> <span class="nv">SomePrivateClass</span> {}
</li><li>
</li><li><span class="k">public</span> <span class="k">var</span> <span class="nv">somePublicVariable</span> = <span class="m">0</span>
</li><li><span class="k">internal</span> <span class="k">let</span> <span class="nv">someInternalConstant</span> = <span class="m">0</span>
</li><li><span class="k">fileprivate</span> <span class="k">func</span> <span class="nv">someFilePrivateFunction</span>() {}
</li><li><span class="k">private</span> <span class="k">func</span> <span class="nv">somePrivateFunction</span>() {}
</li></ol></pre></div></div>
<p>Unless otherwise specified, the default access level is internal, as described in <a class="reference internal" href="AccessControl.html#ID7"><span class="std std-ref">Default Access Levels</span></a>. This means that <code class="docutils literal"><span class="pre">SomeInternalClass</span></code> and <code class="docutils literal"><span class="pre">someInternalConstant</span></code> can be written without an explicit access-level modifier, and will still have an access level of internal:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">class</span> <span class="nv">SomeInternalClass</span> {}              <span class="c">// implicitly internal</span>
</li><li><span class="k">let</span> <span class="nv">someInternalConstant</span> = <span class="m">0</span>            <span class="c">// implicitly internal</span>
</li></ol></pre></div></div>
</div>
<div class="section" id="ID11">
<a class="dashingAutolink" name="autolink-14"></a><a class="dashAnchor" name="//apple_ref/cpp/Section/Custom%20Types"></a><h2>Custom Types<a class="headerlink" href="AccessControl.html#ID11" title="Permalink to this headline"></a></h2>
<p>If you want to specify an explicit access level for a custom type, do so at the point that you define the type. The new type can then be used wherever its access level permits. For example, if you define a file-private class, that class can only be used as the type of a property, or as a function parameter or return type, in the source file in which the file-private class is defined.</p>
<p>The access control level of a type also affects the default access level of that type&rsquo;s <em>members</em> (its properties, methods, initializers, and subscripts). If you define a type&rsquo;s access level as private or file private, the default access level of its members will also be private or file private. If you define a type&rsquo;s access level as internal or public (or use the default access level of internal without specifying an access level explicitly), the default access level of the type&rsquo;s members will be internal.</p>
<div class="admonition important">
<p class="first admonition-title">Important</p>
<p class="last">A public type defaults to having internal members, not public members. If you want a type member to be public, you must explicitly mark it as such. This requirement ensures that the public-facing API for a type is something you opt in to publishing, and avoids presenting the internal workings of a type as public API by mistake.</p>
</div>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">public</span> <span class="k">class</span> <span class="nv">SomePublicClass</span> {                  <span class="c">// explicitly public class</span>
</li><li>    <span class="k">public</span> <span class="k">var</span> <span class="nv">somePublicProperty</span> = <span class="m">0</span>            <span class="c">// explicitly public class member</span>
</li><li>    <span class="k">var</span> <span class="nv">someInternalProperty</span> = <span class="m">0</span>                 <span class="c">// implicitly internal class member</span>
</li><li>    <span class="k">fileprivate</span> <span class="k">func</span> <span class="nv">someFilePrivateMethod</span>() {}  <span class="c">// explicitly file-private class member</span>
</li><li>    <span class="k">private</span> <span class="k">func</span> <span class="nv">somePrivateMethod</span>() {}          <span class="c">// explicitly private class member</span>
</li><li>}
</li><li>
</li><li><span class="k">class</span> <span class="nv">SomeInternalClass</span> {                       <span class="c">// implicitly internal class</span>
</li><li>    <span class="k">var</span> <span class="nv">someInternalProperty</span> = <span class="m">0</span>                 <span class="c">// implicitly internal class member</span>
</li><li>    <span class="k">fileprivate</span> <span class="k">func</span> <span class="nv">someFilePrivateMethod</span>() {}  <span class="c">// explicitly file-private class member</span>
</li><li>    <span class="k">private</span> <span class="k">func</span> <span class="nv">somePrivateMethod</span>() {}          <span class="c">// explicitly private class member</span>
</li><li>}
</li><li>
</li><li><span class="k">fileprivate</span> <span class="k">class</span> <span class="nv">SomeFilePrivateClass</span> {        <span class="c">// explicitly file-private class</span>
</li><li>    <span class="k">func</span> <span class="nv">someFilePrivateMethod</span>() {}              <span class="c">// implicitly file-private class member</span>
</li><li>    <span class="k">private</span> <span class="k">func</span> <span class="nv">somePrivateMethod</span>() {}          <span class="c">// explicitly private class member</span>
</li><li>}
</li><li>
</li><li><span class="k">private</span> <span class="k">class</span> <span class="nv">SomePrivateClass</span> {                <span class="c">// explicitly private class</span>
</li><li>    <span class="k">func</span> <span class="nv">somePrivateMethod</span>() {}                  <span class="c">// implicitly private class member</span>
</li><li>}
</li></ol></pre></div></div>
<div class="section" id="ID12">
<h3>Tuple Types<a class="headerlink" href="AccessControl.html#ID12" title="Permalink to this headline"></a></h3>
<p>The access level for a tuple type is the most restrictive access level of all types used in that tuple. For example, if you compose a tuple from two different types, one with internal access and one with private access, the access level for that compound tuple type will be private.</p>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p class="last">Tuple types don&rsquo;t have a standalone definition in the way that classes, structures, enumerations, and functions do. A tuple type&rsquo;s access level is deduced automatically when the tuple type is used, and can&rsquo;t be specified explicitly.</p>
</div>
</div>
<div class="section" id="ID13">
<h3>Function Types<a class="headerlink" href="AccessControl.html#ID13" title="Permalink to this headline"></a></h3>
<p>The access level for a function type is calculated as the most restrictive access level of the function&rsquo;s parameter types and return type. You must specify the access level explicitly as part of the function&rsquo;s definition if the function&rsquo;s calculated access level doesn&rsquo;t match the contextual default.</p>
<p>The example below defines a global function called <code class="docutils literal"><span class="pre">someFunction()</span></code>, without providing a specific access-level modifier for the function itself. You might expect this function to have the default access level of &ldquo;internal&rdquo;, but this isn&rsquo;t the case. In fact, <code class="docutils literal"><span class="pre">someFunction()</span></code> won&rsquo;t compile as written below:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">func</span> <span class="nv">someFunction</span>() -&gt; (<span class="nc">SomeInternalClass</span>, <span class="nc">SomePrivateClass</span>) {
</li><li>    <span class="c">// function implementation goes here</span>
</li><li>}
</li></ol></pre></div></div>
<p>The function&rsquo;s return type is a tuple type composed from two of the custom classes defined above in <a class="reference internal" href="AccessControl.html#ID11"><span class="std std-ref">Custom Types</span></a>. One of these classes is defined as internal, and the other is defined as private. Therefore, the overall access level of the compound tuple type is private (the minimum access level of the tuple&rsquo;s constituent types).</p>
<p>Because the function&rsquo;s return type is private, you must mark the function&rsquo;s overall access level with the <code class="docutils literal"><span class="pre">private</span></code> modifier for the function declaration to be valid:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">private</span> <span class="k">func</span> <span class="nv">someFunction</span>() -&gt; (<span class="nc">SomeInternalClass</span>, <span class="nc">SomePrivateClass</span>) {
</li><li>    <span class="c">// function implementation goes here</span>
</li><li>}
</li></ol></pre></div></div>
<p>It&rsquo;s not valid to mark the definition of <code class="docutils literal"><span class="pre">someFunction()</span></code> with the <code class="docutils literal"><span class="pre">public</span></code> or <code class="docutils literal"><span class="pre">internal</span></code> modifiers, or to use the default setting of internal, because public or internal users of the function might not have appropriate access to the private class used in the function&rsquo;s return type.</p>
</div>
<div class="section" id="ID14">
<h3>Enumeration Types<a class="headerlink" href="AccessControl.html#ID14" title="Permalink to this headline"></a></h3>
<p>The individual cases of an enumeration automatically receive the same access level as the enumeration they belong to. You can&rsquo;t specify a different access level for individual enumeration cases.</p>
<p>In the example below, the <code class="docutils literal"><span class="pre">CompassPoint</span></code> enumeration has an explicit access level of public. The enumeration cases <code class="docutils literal"><span class="pre">north</span></code>, <code class="docutils literal"><span class="pre">south</span></code>, <code class="docutils literal"><span class="pre">east</span></code>, and <code class="docutils literal"><span class="pre">west</span></code> therefore also have an access level of public:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">public</span> <span class="k">enum</span> <span class="nv">CompassPoint</span> {
</li><li>    <span class="k">case</span> <span class="nv">north</span>
</li><li>    <span class="k">case</span> <span class="nv">south</span>
</li><li>    <span class="k">case</span> <span class="nv">east</span>
</li><li>    <span class="k">case</span> <span class="nv">west</span>
</li><li>}
</li></ol></pre></div></div>
<div class="section" id="ID468">
<h4>Raw Values and Associated Values<a class="headerlink" href="AccessControl.html#ID468" title="Permalink to this headline"></a></h4>
<p>The types used for any raw values or associated values in an enumeration definition must have an access level at least as high as the enumeration&rsquo;s access level. You can&rsquo;t use a private type as the raw-value type of an enumeration with an internal access level, for example.</p>
</div>
</div>
<div class="section" id="ID15">
<h3>Nested Types<a class="headerlink" href="AccessControl.html#ID15" title="Permalink to this headline"></a></h3>
<p>Nested types defined within a private type have an automatic access level of private. Nested types defined within a file-private type have an automatic access level of file private. Nested types defined within a public type or an internal type have an automatic access level of internal. If you want a nested type within a public type to be publicly available, you must explicitly declare the nested type as public.</p>
</div>
</div>
<div class="section" id="ID16">
<a class="dashingAutolink" name="autolink-15"></a><a class="dashAnchor" name="//apple_ref/cpp/Section/Subclassing"></a><h2>Subclassing<a class="headerlink" href="AccessControl.html#ID16" title="Permalink to this headline"></a></h2>
<p>You can subclass any class that can be accessed in the current access context. A subclass can&rsquo;t have a higher access level than its superclass&mdash;for example, you can&rsquo;t write a public subclass of an internal superclass.</p>
<p>In addition, you can override any class member (method, property, initializer, or subscript) that is visible in a certain access context.</p>
<p>An override can make an inherited class member more accessible than its superclass version. In the example below, class <code class="docutils literal"><span class="pre">A</span></code> is a public class with a file-private method called <code class="docutils literal"><span class="pre">someMethod()</span></code>. Class <code class="docutils literal"><span class="pre">B</span></code> is a subclass of <code class="docutils literal"><span class="pre">A</span></code>, with a reduced access level of &ldquo;internal&rdquo;. Nonetheless, class <code class="docutils literal"><span class="pre">B</span></code> provides an override of <code class="docutils literal"><span class="pre">someMethod()</span></code> with an access level of &ldquo;internal&rdquo;, which is <em>higher</em> than the original implementation of <code class="docutils literal"><span class="pre">someMethod()</span></code>:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">public</span> <span class="k">class</span> <span class="nv">A</span> {
</li><li>    <span class="k">fileprivate</span> <span class="k">func</span> <span class="nv">someMethod</span>() {}
</li><li>}
</li><li>
</li><li><span class="k">internal</span> <span class="k">class</span> <span class="nv">B</span>: <span class="nc">A</span> {
</li><li>    <span class="k">override</span> <span class="k">internal</span> <span class="k">func</span> <span class="nv">someMethod</span>() {}
</li><li>}
</li></ol></pre></div></div>
<p>It&rsquo;s even valid for a subclass member to call a superclass member that has lower access permissions than the subclass member, as long as the call to the superclass&rsquo;s member takes place within an allowed access level context (that is, within the same source file as the superclass for a file-private member call, or within the same module as the superclass for an internal member call):</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">public</span> <span class="k">class</span> <span class="nv">A</span> {
</li><li>    <span class="k">fileprivate</span> <span class="k">func</span> <span class="nv">someMethod</span>() {}
</li><li>}
</li><li>
</li><li><span class="k">internal</span> <span class="k">class</span> <span class="nv">B</span>: <span class="nc">A</span> {
</li><li>    <span class="k">override</span> <span class="k">internal</span> <span class="k">func</span> <span class="nv">someMethod</span>() {
</li><li>        <span class="k">super</span>.<span class="nv">someMethod</span>()
</li><li>    }
</li><li>}
</li></ol></pre></div></div>
<p>Because superclass <code class="docutils literal"><span class="pre">A</span></code> and subclass <code class="docutils literal"><span class="pre">B</span></code> are defined in the same source file, it&rsquo;s valid for the <code class="docutils literal"><span class="pre">B</span></code> implementation of <code class="docutils literal"><span class="pre">someMethod()</span></code> to call <code class="docutils literal"><span class="pre">super.someMethod()</span></code>.</p>
</div>
<div class="section" id="ID17">
<a class="dashingAutolink" name="autolink-16"></a><a class="dashAnchor" name="//apple_ref/cpp/Section/Constants%2C%20Variables%2C%20Properties%2C%20and%20Subscripts"></a><h2>Constants, Variables, Properties, and Subscripts<a class="headerlink" href="AccessControl.html#ID17" title="Permalink to this headline"></a></h2>
<p>A constant, variable, or property can&rsquo;t be more public than its type. It&rsquo;s not valid to write a public property with a private type, for example. Similarly, a subscript can&rsquo;t be more public than either its index type or return type.</p>
<p>If a constant, variable, property, or subscript makes use of a private type, the constant, variable, property, or subscript must also be marked as <code class="docutils literal"><span class="pre">private</span></code>:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">private</span> <span class="k">var</span> <span class="nv">privateInstance</span> = <span class="nv">SomePrivateClass</span>()
</li></ol></pre></div></div>
<div class="section" id="ID18">
<h3>Getters and Setters<a class="headerlink" href="AccessControl.html#ID18" title="Permalink to this headline"></a></h3>
<p>Getters and setters for constants, variables, properties, and subscripts automatically receive the same access level as the constant, variable, property, or subscript they belong to.</p>
<p>You can give a setter a <em>lower</em> access level than its corresponding getter, to restrict the read-write scope of that variable, property, or subscript. You assign a lower access level by writing <code class="docutils literal"><span class="pre">fileprivate(set)</span></code>, <code class="docutils literal"><span class="pre">private(set)</span></code>, or <code class="docutils literal"><span class="pre">internal(set)</span></code> before the <code class="docutils literal"><span class="pre">var</span></code> or <code class="docutils literal"><span class="pre">subscript</span></code> introducer.</p>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p class="last">This rule applies to stored properties as well as computed properties. Even though you don&rsquo;t write an explicit getter and setter for a stored property, Swift still synthesizes an implicit getter and setter for you to provide access to the stored property&rsquo;s backing storage. Use <code class="docutils literal"><span class="pre">fileprivate(set)</span></code>, <code class="docutils literal"><span class="pre">private(set)</span></code>, and <code class="docutils literal"><span class="pre">internal(set)</span></code> to change the access level of this synthesized setter in exactly the same way as for an explicit setter in a computed property.</p>
</div>
<p>The example below defines a structure called <code class="docutils literal"><span class="pre">TrackedString</span></code>, which keeps track of the number of times a string property is modified:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">struct</span> <span class="nv">TrackedString</span> {
</li><li>    <span class="k">private(set)</span> <span class="k">var</span> <span class="nv">numberOfEdits</span> = <span class="m">0</span>
</li><li>    <span class="k">var</span> <span class="nv">value</span>: <span class="nc">String</span> = <span class="s">&#34;&#34;</span> {
</li><li>        <span class="k">didSet</span> {
</li><li>            <span class="nv">numberOfEdits</span> += <span class="m">1</span>
</li><li>        }
</li><li>    }
</li><li>}
</li></ol></pre></div></div>
<p>The <code class="docutils literal"><span class="pre">TrackedString</span></code> structure defines a stored string property called <code class="docutils literal"><span class="pre">value</span></code>, with an initial value of <code class="docutils literal"><span class="pre">&#34;&#34;</span></code> (an empty string). The structure also defines a stored integer property called <code class="docutils literal"><span class="pre">numberOfEdits</span></code>, which is used to track the number of times that <code class="docutils literal"><span class="pre">value</span></code> is modified. This modification tracking is implemented with a <code class="docutils literal"><span class="pre">didSet</span></code> property observer on the <code class="docutils literal"><span class="pre">value</span></code> property, which increments <code class="docutils literal"><span class="pre">numberOfEdits</span></code> every time the <code class="docutils literal"><span class="pre">value</span></code> property is set to a new value.</p>
<p>The <code class="docutils literal"><span class="pre">TrackedString</span></code> structure and the <code class="docutils literal"><span class="pre">value</span></code> property don&rsquo;t provide an explicit access-level modifier, and so they both receive the default access level of internal. However, the access level for the <code class="docutils literal"><span class="pre">numberOfEdits</span></code> property is marked with a <code class="docutils literal"><span class="pre">private(set)</span></code> modifier to indicate that the property&rsquo;s getter still has the default access level of internal, but the property is settable only from within code that&rsquo;s part of the <code class="docutils literal"><span class="pre">TrackedString</span></code> structure. This enables <code class="docutils literal"><span class="pre">TrackedString</span></code> to modify the <code class="docutils literal"><span class="pre">numberOfEdits</span></code> property internally, but to present the property as a read-only property when it&rsquo;s used outside the structure&rsquo;s definition.</p>
<p>If you create a <code class="docutils literal"><span class="pre">TrackedString</span></code> instance and modify its string value a few times, you can see the <code class="docutils literal"><span class="pre">numberOfEdits</span></code> property value update to match the number of modifications:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">var</span> <span class="nv">stringToEdit</span> = <span class="nv">TrackedString</span>()
</li><li><span class="nv">stringToEdit</span>.<span class="nv">value</span> = <span class="s">&#34;This string will be tracked.&#34;</span>
</li><li><span class="nv">stringToEdit</span>.<span class="nv">value</span> += <span class="s">&#34; This edit will increment numberOfEdits.&#34;</span>
</li><li><span class="nv">stringToEdit</span>.<span class="nv">value</span> += <span class="s">&#34; So will this one.&#34;</span>
</li><li><span class="nv">print</span>(<span class="s">&#34;The number of edits is </span>\<span class="p">(</span><span class="nv">stringToEdit</span>.<span class="nv">numberOfEdits</span><span class="p">)</span><span class="s">&#34;</span>)
</li><li><span class="c">// Prints &#34;The number of edits is 3&#34;</span>
</li></ol></pre></div></div>
<p>Although you can query the current value of the <code class="docutils literal"><span class="pre">numberOfEdits</span></code> property from within another source file, you can&rsquo;t <em>modify</em> the property from another source file. This restriction protects the implementation details of the <code class="docutils literal"><span class="pre">TrackedString</span></code> edit-tracking functionality, while still providing convenient access to an aspect of that functionality.</p>
<p>Note that you can assign an explicit access level for both a getter and a setter if required. The example below shows a version of the <code class="docutils literal"><span class="pre">TrackedString</span></code> structure in which the structure is defined with an explicit access level of public. The structure&rsquo;s members (including the <code class="docutils literal"><span class="pre">numberOfEdits</span></code> property) therefore have an internal access level by default. You can make the structure&rsquo;s <code class="docutils literal"><span class="pre">numberOfEdits</span></code> property getter public, and its property setter private, by combining the <code class="docutils literal"><span class="pre">public</span></code> and <code class="docutils literal"><span class="pre">private(set)</span></code> access-level modifiers:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">public</span> <span class="k">struct</span> <span class="nv">TrackedString</span> {
</li><li>    <span class="k">public</span> <span class="k">private(set)</span> <span class="k">var</span> <span class="nv">numberOfEdits</span> = <span class="m">0</span>
</li><li>    <span class="k">public</span> <span class="k">var</span> <span class="nv">value</span>: <span class="nc">String</span> = <span class="s">&#34;&#34;</span> {
</li><li>        <span class="k">didSet</span> {
</li><li>            <span class="nv">numberOfEdits</span> += <span class="m">1</span>
</li><li>        }
</li><li>    }
</li><li>    <span class="k">public</span> <span class="k">init</span>() {}
</li><li>}
</li></ol></pre></div></div>
</div>
</div>
<div class="section" id="ID19">
<a class="dashingAutolink" name="autolink-17"></a><a class="dashAnchor" name="//apple_ref/cpp/Section/Initializers"></a><h2>Initializers<a class="headerlink" href="AccessControl.html#ID19" title="Permalink to this headline"></a></h2>
<p>Custom initializers can be assigned an access level less than or equal to the type that they initialize. The only exception is for required initializers (as defined in <a class="reference internal" href="Initialization.html#ID231"><span class="std std-ref">Required Initializers</span></a>). A required initializer must have the same access level as the class it belongs to.</p>
<p>As with function and method parameters, the types of an initializer&rsquo;s parameters can&rsquo;t be more private than the initializer&rsquo;s own access level.</p>
<div class="section" id="ID20">
<h3>Default Initializers<a class="headerlink" href="AccessControl.html#ID20" title="Permalink to this headline"></a></h3>
<p>As described in <a class="reference internal" href="Initialization.html#ID213"><span class="std std-ref">Default Initializers</span></a>, Swift automatically provides a <em>default initializer</em> without any arguments for any structure or base class that provides default values for all of its properties and doesn&rsquo;t provide at least one initializer itself.</p>
<p>A default initializer has the same access level as the type it initializes, unless that type is defined as <code class="docutils literal"><span class="pre">public</span></code>. For a type that is defined as <code class="docutils literal"><span class="pre">public</span></code>, the default initializer is considered internal. If you want a public type to be initializable with a no-argument initializer when used in another module, you must explicitly provide a public no-argument initializer yourself as part of the type&rsquo;s definition.</p>
</div>
<div class="section" id="ID21">
<h3>Default Memberwise Initializers for Structure Types<a class="headerlink" href="AccessControl.html#ID21" title="Permalink to this headline"></a></h3>
<p>The default memberwise initializer for a structure type is considered private if any of the structure&rsquo;s stored properties are private. Likewise, if any of the structure&rsquo;s stored properties are file private, the initializer is file private. Otherwise, the initializer has an access level of internal.</p>
<p>As with the default initializer above, if you want a public structure type to be initializable with a memberwise initializer when used in another module, you must provide a public memberwise initializer yourself as part of the type&rsquo;s definition.</p>
</div>
</div>
<div class="section" id="ID22">
<a class="dashingAutolink" name="autolink-18"></a><a class="dashAnchor" name="//apple_ref/cpp/Section/Protocols"></a><h2>Protocols<a class="headerlink" href="AccessControl.html#ID22" title="Permalink to this headline"></a></h2>
<p>If you want to assign an explicit access level to a protocol type, do so at the point that you define the protocol. This enables you to create protocols that can only be adopted within a certain access context.</p>
<p>The access level of each requirement within a protocol definition is automatically set to the same access level as the protocol. You can&rsquo;t set a protocol requirement to a different access level than the protocol it supports. This ensures that all of the protocol&rsquo;s requirements will be visible on any type that adopts the protocol.</p>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p class="last">If you define a public protocol, the protocol&rsquo;s requirements require a public access level for those requirements when they&rsquo;re implemented. This behavior is different from other types, where a public type definition implies an access level of internal for the type&rsquo;s members.</p>
</div>
<div class="section" id="ID23">
<h3>Protocol Inheritance<a class="headerlink" href="AccessControl.html#ID23" title="Permalink to this headline"></a></h3>
<p>If you define a new protocol that inherits from an existing protocol, the new protocol can have at most the same access level as the protocol it inherits from. You can&rsquo;t write a public protocol that inherits from an internal protocol, for example.</p>
</div>
<div class="section" id="ID24">
<h3>Protocol Conformance<a class="headerlink" href="AccessControl.html#ID24" title="Permalink to this headline"></a></h3>
<p>A type can conform to a protocol with a lower access level than the type itself. For example, you can define a public type that can be used in other modules, but whose conformance to an internal protocol can only be used within the internal protocol&rsquo;s defining module.</p>
<p>The context in which a type conforms to a particular protocol is the minimum of the type&rsquo;s access level and the protocol&rsquo;s access level. If a type is public, but a protocol it conforms to is internal, the type&rsquo;s conformance to that protocol is also internal.</p>
<p>When you write or extend a type to conform to a protocol, you must ensure that the type&rsquo;s implementation of each protocol requirement has at least the same access level as the type&rsquo;s conformance to that protocol. For example, if a public type conforms to an internal protocol, the type&rsquo;s implementation of each protocol requirement must be at least &ldquo;internal&rdquo;.</p>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p class="last">In Swift, as in Objective-C, protocol conformance is global&mdash;it isn&rsquo;t possible for a type to conform to a protocol in two different ways within the same program.</p>
</div>
</div>
</div>
<div class="section" id="ID25">
<a class="dashingAutolink" name="autolink-19"></a><a class="dashAnchor" name="//apple_ref/cpp/Section/Extensions"></a><h2>Extensions<a class="headerlink" href="AccessControl.html#ID25" title="Permalink to this headline"></a></h2>
<p>You can extend a class, structure, or enumeration in any access context in which the class, structure, or enumeration is available. Any type members added in an extension have the same default access level as type members declared in the original type being extended. If you extend a public or internal type, any new type members you add have a default access level of internal. If you extend a file-private type, any new type members you add have a default access level of file private. If you extend a private type, any new type members you add have a default access level of private.</p>
<p>Alternatively, you can mark an extension with an explicit access-level modifier (for example, <code class="docutils literal"><span class="pre">private</span> <span class="pre">extension</span></code>) to set a new default access level for all members defined within the extension. This new default can still be overridden within the extension for individual type members.</p>
<p>You can&rsquo;t provide an explicit access-level modifier for an extension if you&rsquo;re using that extension to add protocol conformance. Instead, the protocol&rsquo;s own access level is used to provide the default access level for each protocol requirement implementation within the extension.</p>
<div class="section" id="ID559">
<h3>Private Members in Extensions<a class="headerlink" href="AccessControl.html#ID559" title="Permalink to this headline"></a></h3>
<p>Extensions that are in the same file as the class, structure, or enumeration that they extend behave as if the code in the extension had been written as part of the original type&rsquo;s declaration. As a result, you can:</p>
<ul class="simple">
<li>Declare a private member in the original declaration, and access that member from extensions in the same file.</li>
<li>Declare a private member in one extension, and access that member from another extension in the same file.</li>
<li>Declare a private member in an extension, and access that member from the original declaration in the same file.</li>
</ul>
<p>This behavior means you can use extensions in the same way to organize your code, whether or not your types have private entities. For example, given the following simple protocol:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">protocol</span> <span class="nv">SomeProtocol</span> {
</li><li>    <span class="k">func</span> <span class="nv">doSomething</span>()
</li><li>}
</li></ol></pre></div></div>
<p>You can use an extension to add protocol conformance, like this:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">struct</span> <span class="nv">SomeStruct</span> {
</li><li>    <span class="k">private</span> <span class="k">var</span> <span class="nv">privateVariable</span> = <span class="m">12</span>
</li><li>}
</li><li>
</li><li><span class="k">extension</span> <span class="nc">SomeStruct</span>: <span class="nc">SomeProtocol</span> {
</li><li>    <span class="k">func</span> <span class="nv">doSomething</span>() {
</li><li>        <span class="nv">print</span>(<span class="nv">privateVariable</span>)
</li><li>    }
</li><li>}
</li></ol></pre></div></div>
</div>
</div>
<div class="section" id="ID26">
<a class="dashingAutolink" name="autolink-20"></a><a class="dashAnchor" name="//apple_ref/cpp/Section/Generics"></a><h2>Generics<a class="headerlink" href="AccessControl.html#ID26" title="Permalink to this headline"></a></h2>
<p>The access level for a generic type or generic function is the minimum of the access level of the generic type or function itself and the access level of any type constraints on its type parameters.</p>
</div>
<div class="section" id="ID27">
<a class="dashingAutolink" name="autolink-21"></a><a class="dashAnchor" name="//apple_ref/cpp/Section/Type%20Aliases"></a><h2>Type Aliases<a class="headerlink" href="AccessControl.html#ID27" title="Permalink to this headline"></a></h2>
<p>Any type aliases you define are treated as distinct types for the purposes of access control. A type alias can have an access level less than or equal to the access level of the type it aliases. For example, a private type alias can alias a private, file-private, internal, public, or open type, but a public type alias can&rsquo;t alias an internal, file-private, or private type.</p>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p class="last">This rule also applies to type aliases for associated types used to satisfy protocol conformances.</p>
</div>
</div>
</div>


    </article>
    <div class="next_previous">
        <p class="previous"><a href="MemorySafety.html">Memory Safety</a></p>
        <p class="next"><a href="AdvancedOperators.html">Advanced Operators</a></p>
    </div>

    <div class="admonition-beta admonition">
        <p class="first admonition-title">Beta Software</p>
        <p>
          This documentation contains preliminary information about an API or technology in development.
          This information is subject to change, and software implemented according to this documentation should be tested with final operating system software.
        </p>
        <p class="last"><a class="reference external" href="https://developer.apple.com/support/beta-software/">Learn more about using Apple&#39;s beta software</a></p>
    </div>
</main>


<footer role="contentinfo">
  <aside>
    <a href="https://swift.org/atom.xml" title="Subscribe to Site Updates"><i class="feed">Subscribe</i></a>
    <a href="https://twitter.com/swiftlang" rel="nofollow" title="Follow @SwiftLang on Twitter"><i class="twitter">Twitter</i></a>
  </aside>

  <p class="copyright">Copyright &copy; 2018 Apple Inc. All rights reserved.</p>
  <p class="trademark">Swift and the Swift logo are trademarks of Apple Inc.</p>
  <p class="privacy">
    <a href="https://www.apple.com/privacy/privacy-policy/">Privacy Policy</a>
    <a href="https://www.apple.com/legal/privacy/en-ww/cookies/">Cookies</a>
  </p>
</footer>
<div id="jump_to_overlay"></div>
<script src="../_static/javascripts/application.js"></script>
  

</body></html>